# gnums

gnums is the gui version of my program <a href="https://tildegit.org/sloum/nums" target="_blank">nums</a> (ie. gui/graphical nums). It is a <a href="https://en.wikipedia.org/wiki/Reverse_Polish_notation" target="_blank">reverse polish notation</a> calculator.

![screenshot of the gnums calculator interface](gnums.png)

## Usage

On initial load some sensible defaults will be set up. Other options are avialable in the settings menu. You will see a stack view on the left, the calculator buttons on the right, and the main input/output at the top. The main input/output will show what you are typing as you type it and will show the current TOS/total after performing an operation (but before more numerical entry), similar to a regular calculator. The stack view will show the full input stack and allow for more complex operations.

At present there is no keyboard input. This is on the TODO list and should get added in the near future (after all, who really wants to use a mouse for anything?).

## Dependencies

- Go >= 1.16
- OSX
    - xcode-select (`xcode-select --install`)
- Windows
    - <a href="https://github.com/brechtsanders/winlibs_mingw/releases/tag/10.2.0-11.0.0-8.0.0-r8" target="_blank">mingw</a>
- Debian/derivatives (package names may vary for other distros)
    - `apt install libx11-dev libxcursor-dev libxrandr-dev libxinerama-dev libxi-dev libglx-dev libgl1-mesa-dev libxxf86vm-dev`


## Building

Minor build variations can be found for each system. Using `upx` will reduce binary size by a good bit for any of these systems. After running the build command, and optionally running upx, move the resulting binary onto your path and you are good to go. Makefile coming soon<sup>TM</sup>.

### OSX

`go build -ldflags "-s -w" .`

### Windows

`go build -ldflags "-s -w -H=windowsgui -extldflags=-static" .`

### Linux

`go build`

